## shim 0.9+1474479173.6c180c6

=== Makefile ===
VERSION		= 0.9
RELEASE		:=
ifneq ($(RELEASE),"")
	RELEASE:="-$(RELEASE)"
endif

CC		= $(CROSS_COMPILE)gcc
LD		= $(CROSS_COMPILE)ld
OBJCOPY		= $(CROSS_COMPILE)objcopy

ARCH		= $(shell $(CC) -dumpmachine | cut -f1 -d- | sed s,i[3456789]86,ia32,)
OBJCOPY_GTE224  = $(shell expr `$(OBJCOPY) --version |grep ^"GNU objcopy" | sed 's/^.*\((.*)\|version\) //g' | cut -f1-2 -d.` \>= 2.24)

SUBDIRS		= Cryptlib lib

EFI_INCLUDE	:= /usr/include/efi
EFI_INCLUDES	= -nostdinc -ICryptlib -ICryptlib/Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol -I$(shell pwd)/include

LIB_GCC		= $(shell $(CC) -print-libgcc-file-name)
EFI_LIBS	= -lefi -lgnuefi --start-group Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a --end-group $(LIB_GCC) 

EFI_CRT_OBJS 	= $(EFI_PATH)/crt0-efi-$(ARCH).o
EFI_LDS		= elf_$(ARCH)_efi.lds

DEFAULT_LOADER	:= \\\\grub.efi
CFLAGS		= -ggdb -O0 -fno-stack-protector -fno-strict-aliasing -fpic \
		  -fshort-wchar -Wall -Wsign-compare -Werror -fno-builtin \
		  -Werror=sign-compare -ffreestanding -std=gnu89 \
		  -I$(shell $(CC) -print-file-name=include) \
		  "-DDEFAULT_LOADER=L\"$(DEFAULT_LOADER)\"" \
		  "-DDEFAULT_LOADER_CHAR=\"$(DEFAULT_LOADER)\"" \
		  $(EFI_INCLUDES)
SHIMNAME	= shim
MMNAME		= MokManager
FBNAME		= fallback

ifneq ($(origin OVERRIDE_SECURITY_POLICY), undefined)
	CFLAGS	+= -DOVERRIDE_SECURITY_POLICY
endif

ifneq ($(origin ENABLE_HTTPBOOT), undefined)
	CFLAGS	+= -DENABLE_HTTPBOOT
endif

ifeq ($(ARCH),x86_64)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc \
		-maccumulate-outgoing-args \
		-DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI \
		-DNO_BUILTIN_VA_FUNCS \
		-DMDE_CPU_X64 "-DEFI_ARCH=L\"x64\"" -DPAGE_SIZE=4096 \
		"-DDEBUGDIR=L\"/usr/lib/debug/usr/share/shim/x64-$(VERSION)$(RELEASE)/\""
	MMNAME	= mmx64
	FBNAME	= fbx64
	SHIMNAME= shimx64
	EFI_PATH:=/usr/lib64/gnuefi
	LIB_PATH:=/usr/lib64

endif
ifeq ($(ARCH),ia32)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc \
		-maccumulate-outgoing-args -m32 \
		-DMDE_CPU_IA32 "-DEFI_ARCH=L\"ia32\"" -DPAGE_SIZE=4096 \
		"-DDEBUGDIR=L\"/usr/lib/debug/usr/share/shim/ia32-$(VERSION)$(RELEASE)/\""
	MMNAME	= mmia32
	FBNAME	= fbia32
	SHIMNAME= shimia32
	EFI_PATH:=/usr/lib/gnuefi
	LIB_PATH:=/usr/lib
endif
ifeq ($(ARCH),aarch64)
	CFLAGS += -DMDE_CPU_AARCH64 "-DEFI_ARCH=L\"aa64\"" -DPAGE_SIZE=4096 \
		"-DDEBUGDIR=L\"/usr/lib/debug/usr/share/shim/aa64-$(VERSION)$(RELEASE)/\""
	MMNAME	= mmaa64
	FBNAME	= fbaa64
	SHIMNAME= shimaa64
	EFI_PATH:=/usr/lib64/gnuefi
	LIB_PATH:=/usr/lib64
endif

ifneq ($(origin VENDOR_CERT_FILE), undefined)
	CFLAGS += -DVENDOR_CERT_FILE=\"$(VENDOR_CERT_FILE)\"
endif
ifneq ($(origin VENDOR_DBX_FILE), undefined)
	CFLAGS += -DVENDOR_DBX_FILE=\"$(VENDOR_DBX_FILE)\"
endif

LDFLAGS		= --hash-style=sysv -nostdlib -znocombreloc -T $(EFI_LDS) -shared -Bsymbolic -L$(EFI_PATH) -L$(LIB_PATH) -LCryptlib -LCryptlib/OpenSSL $(EFI_CRT_OBJS) --build-id=sha1

TARGET	= $(SHIMNAME).efi $(MMNAME).efi.signed $(FBNAME).efi.signed
OBJS	= shim.o netboot.o cert.o replacements.o tpm.o version.o
KEYS	= shim_cert.h ocsp.* ca.* shim.crt shim.csr shim.p12 shim.pem shim.key shim.cer
SOURCES	= shim.c shim.h netboot.c include/PeImage.h include/wincert.h include/console.h replacements.c replacements.h tpm.c tpm.h version.c version.h
MOK_OBJS = MokManager.o PasswordCrypt.o crypt_blowfish.o
MOK_SOURCES = MokManager.c shim.h include/console.h PasswordCrypt.c PasswordCrypt.h crypt_blowfish.c crypt_blowfish.h
FALLBACK_OBJS = fallback.o
FALLBACK_SRCS = fallback.c

ifneq ($(origin ENABLE_HTTPBOOT), undefined)
	OBJS += httpboot.o
	SOURCES += httpboot.c httpboot.h
endif

all: $(TARGET)

shim.crt:
	./make-certs shim shim@xn--u4h.net all codesign 1.3.6.1.4.1.311.10.3.1 </dev/null

shim.cer: shim.crt
	openssl x509 -outform der -in $< -out $@

shim_cert.h: shim.cer
	echo "static UINT8 shim_cert[] = {" > $@
	hexdump -v -e '1/1 "0x%02x, "' $< >> $@
	echo "};" >> $@

version.c : version.c.in
	sed	-e "s,@@VERSION@@,$(VERSION)," \
		-e "s,@@UNAME@@,$(shell uname -a)," \
		-e "s,@@COMMIT@@,$(shell if [ -d .git ] ; then git log -1 --pretty=format:%H ; elif [ -f commit ]; then cat commit ; else echo commit id not available; fi)," \
		< version.c.in > version.c

certdb/secmod.db: shim.crt
	-mkdir certdb
	pk12util -d certdb/ -i shim.p12 -W "" -K ""
	certutil -d certdb/ -A -i shim.crt -n shim -t u

shim.o: $(SOURCES) shim_cert.h
shim.o: $(wildcard *.h)

cert.o : cert.S
	$(CC) $(CFLAGS) -c -o $@ $<

$(SHIMNAME).so: $(OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)

fallback.o: $(FALLBACK_SRCS)

$(FBNAME).so: $(FALLBACK_OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)

MokManager.o: $(MOK_SOURCES)

$(MMNAME).so: $(MOK_OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS) lib/lib.a

Cryptlib/libcryptlib.a:
	$(MAKE) -C Cryptlib

Cryptlib/OpenSSL/libopenssl.a:
	$(MAKE) -C Cryptlib/OpenSSL

lib/lib.a:
	$(MAKE) CFLAGS="$(CFLAGS)" -C lib

ifeq ($(ARCH),aarch64)
FORMAT		:= -O binary
SUBSYSTEM	:= 0xa
LDFLAGS		+= --defsym=EFI_SUBSYSTEM=$(SUBSYSTEM)
endif

ifeq ($(ARCH),arm)
FORMAT		:= -O binary
SUBSYSTEM	:= 0xa
LDFLAGS		+= --defsym=EFI_SUBSYSTEM=$(SUBSYSTEM)
endif

FORMAT		?= --target efi-app-$(ARCH)

%.efi: %.so
ifneq ($(OBJCOPY_GTE224),1)
	$(error objcopy >= 2.24 is required)
endif
	$(OBJCOPY) -j .text -j .sdata -j .data \
		-j .dynamic -j .dynsym  -j .rel* \
		-j .rela* -j .reloc -j .eh_frame \
		-j .vendor_cert \
		$(FORMAT)  $^ $@
	$(OBJCOPY) -j .text -j .sdata -j .data \
		-j .dynamic -j .dynsym  -j .rel* \
		-j .rela* -j .reloc -j .eh_frame \
		-j .debug_info -j .debug_abbrev -j .debug_aranges \
		-j .debug_line -j .debug_str -j .debug_ranges \
		-j .note.gnu.build-id \
		$(FORMAT) $^ $@.debug

%.efi.signed: %.efi certdb/secmod.db
	pesign -n certdb -i $< -c "shim" -s -o $@ -f

clean:
	$(MAKE) -C Cryptlib clean
	$(MAKE) -C Cryptlib/OpenSSL clean
	$(MAKE) -C lib clean
	rm -rf $(TARGET) $(OBJS) $(MOK_OBJS) $(FALLBACK_OBJS) $(KEYS) certdb
	rm -f *.debug *.so *.efi *.tar.* version.c

GITTAG = $(VERSION)

test-archive:
	@rm -rf /tmp/shim-$(VERSION) /tmp/shim-$(VERSION)-tmp
	@mkdir -p /tmp/shim-$(VERSION)-tmp
	@git archive --format=tar $(shell git branch | awk '/^*/ { print $$2 }') | ( cd /tmp/shim-$(VERSION)-tmp/ ; tar x )
	@git diff | ( cd /tmp/shim-$(VERSION)-tmp/ ; patch -s -p1 -b -z .gitdiff )
	@mv /tmp/shim-$(VERSION)-tmp/ /tmp/shim-$(VERSION)/
	@git log -1 --pretty=format:%H > /tmp/shim-$(VERSION)/commit
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/shim-$(VERSION).tar.bz2 shim-$(VERSION)
	@rm -rf /tmp/shim-$(VERSION)
	@echo "The archive is in shim-$(VERSION).tar.bz2"

tag:
	git tag --sign $(GITTAG) refs/heads/master

archive: tag
	@rm -rf /tmp/shim-$(VERSION) /tmp/shim-$(VERSION)-tmp
	@mkdir -p /tmp/shim-$(VERSION)-tmp
	@git archive --format=tar $(GITTAG) | ( cd /tmp/shim-$(VERSION)-tmp/ ; tar x )
	@mv /tmp/shim-$(VERSION)-tmp/ /tmp/shim-$(VERSION)/
	@git log -1 --pretty=format:%H > /tmp/shim-$(VERSION)/commit
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/shim-$(VERSION).tar.bz2 shim-$(VERSION)
	@rm -rf /tmp/shim-$(VERSION)
	@echo "The archive is in shim-$(VERSION).tar.bz2"

export ARCH CC LD OBJCOPY EFI_INCLUDE

=== Cryptlib/Makefile ===

EFI_INCLUDES	= -IInclude -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol

CFLAGS		= -ggdb -O0 -I. -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar \
		  -Wall $(EFI_INCLUDES) -std=gnu89 \
		  -ffreestanding -I$(shell $(CC) -print-file-name=include)

ifeq ($(ARCH),x86_64)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc -maccumulate-outgoing-args \
		-DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI -DNO_BUILTIN_VA_FUNCS \
		-DMDE_CPU_IA64
endif
ifeq ($(ARCH),ia32)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc -maccumulate-outgoing-args -m32 \
		-DMDE_CPU_IA32
endif
ifeq ($(ARCH),aarch64)
	CFLAGS	+= -DMDE_CPU_AARCH64
endif
LDFLAGS		= -nostdlib -znocombreloc

TARGET		= libcryptlib.a
OBJS		=   Hash/CryptMd4.o \
		    Hash/CryptMd5.o \
		    Hash/CryptSha1.o \
		    Hash/CryptSha256.o \
		    Hash/CryptSha512.o \
		    Hmac/CryptHmacMd5.o \
		    Hmac/CryptHmacSha1.o \
		    Cipher/CryptAes.o \
		    Cipher/CryptTdes.o \
		    Cipher/CryptArc4.o \
		    Rand/CryptRand.o \
		    Pk/CryptRsaBasic.o \
		    Pk/CryptRsaExtNull.o \
		    Pk/CryptPkcs7SignNull.o \
		    Pk/CryptPkcs7Verify.o \
		    Pk/CryptDhNull.o \
		    Pk/CryptTs.o \
		    Pk/CryptX509.o \
		    Pk/CryptAuthenticode.o \
		    Pem/CryptPem.o \
		    SysCall/CrtWrapper.o \
		    SysCall/TimerWrapper.o \
		    SysCall/BaseMemAllocation.o \
		    SysCall/BaseStrings.o

all: $(TARGET)

libcryptlib.a: $(OBJS)
	ar rcs libcryptlib.a $(OBJS)
clean:
	rm -f $(TARGET) $(OBJS)

=== lib/Makefile ===
TARGET = lib.a

LIBFILES = simple_file.o guid.o console.o execute.o configtable.o shell.o variables.o security_policy.o

EFI_INCLUDES    = -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol -I../include

lib.a: $(LIBFILES)
	ar rcs lib.a $(LIBFILES)

all: $(TARGET)

clean:
	rm -f lib.a
	rm -f $(LIBFILES)

=== Cryptlib/OpenSSL/Makefile ===

EFI_INCLUDES	= -I../Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol -Icrypto/asn1 -Icrypto/evp -Icrypto/modes

CFLAGS		= -ggdb -O0 -I. -I.. -I../Include/ -Icrypto -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar -nostdinc \
		  -ffreestanding -std=gnu89 -I$(shell $(CC) -print-file-name=include) \
		  -Wall $(EFI_INCLUDES) -DL_ENDIAN -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DOPENSSL_SMALL_FOOTPRINT -DPEDANTIC

ifeq ($(ARCH),x86_64)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -maccumulate-outgoing-args \
		-DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI \
		-UNO_BUILTIN_VA_FUNCS -DMDE_CPU_IA64
endif
ifeq ($(ARCH),ia32)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -maccumulate-outgoing-args \
		-m32 -DMDE_CPU_IA32
endif
ifeq ($(ARCH),aarch64)
	CFLAGS	+= -O2 -DMDE_CPU_AARCH64
endif
ifeq ($(ARCH),arm)
	CFLAGS	+= -O2 -DMDE_CPU_ARM
endif
LDFLAGS		= -nostdlib -znocombreloc

TARGET		= libopenssl.a
OBJS		=   crypto/cryptlib.o \
  crypto/mem.o \
  crypto/mem_clr.o \
  crypto/mem_dbg.o \
  crypto/cversion.o \
  crypto/ex_data.o \
  crypto/cpt_err.o \
  crypto/ebcdic.o \
  crypto/uid.o \
  crypto/o_time.o \
  crypto/o_str.o \
  crypto/o_dir.o \
  crypto/o_fips.o \
  crypto/o_init.o \
  crypto/fips_ers.o \
  crypto/md4/md4_dgst.o \
  crypto/md4/md4_one.o \
  crypto/md5/md5_dgst.o \
  crypto/md5/md5_one.o \
  crypto/sha/sha_dgst.o \
  crypto/sha/sha1dgst.o \
  crypto/sha/sha_one.o \
  crypto/sha/sha1_one.o \
  crypto/sha/sha256.o \
  crypto/sha/sha512.o \
  crypto/hmac/hmac.o \
  crypto/hmac/hm_ameth.o \
  crypto/hmac/hm_pmeth.o \
  crypto/des/set_key.o \
  crypto/des/ecb_enc.o \
  crypto/des/cbc_enc.o \
  crypto/des/ecb3_enc.o \
  crypto/des/cfb64enc.o \
  crypto/des/cfb64ede.o \
  crypto/des/cfb_enc.o \
  crypto/des/ofb64ede.o \
  crypto/des/enc_read.o \
  crypto/des/enc_writ.o \
  crypto/des/ofb64enc.o \
  crypto/des/ofb_enc.o \
  crypto/des/str2key.o \
  crypto/des/pcbc_enc.o \
  crypto/des/qud_cksm.o \
  crypto/des/rand_key.o \
  crypto/des/des_enc.o \
  crypto/des/fcrypt_b.o \
  crypto/des/fcrypt.o \
  crypto/des/xcbc_enc.o \
  crypto/des/rpc_enc.o \
  crypto/des/cbc_cksm.o \
  crypto/des/ede_cbcm_enc.o \
  crypto/des/des_old.o \
  crypto/des/des_old2.o \
  crypto/des/read2pwd.o \
  crypto/rc4/rc4_enc.o \
  crypto/rc4/rc4_skey.o \
  crypto/rc4/rc4_utl.o \
  crypto/aes/aes_misc.o \
  crypto/aes/aes_ecb.o \
  crypto/aes/aes_cfb.o \
  crypto/aes/aes_ofb.o \
  crypto/aes/aes_ctr.o \
  crypto/aes/aes_ige.o \
  crypto/aes/aes_wrap.o \
  crypto/aes/aes_core.o \
  crypto/aes/aes_cbc.o \
  crypto/modes/cbc128.o \
  crypto/modes/ctr128.o \
  crypto/modes/cts128.o \
  crypto/modes/cfb128.o \
  crypto/modes/ofb128.o \
  crypto/modes/gcm128.o \
  crypto/modes/ccm128.o \
  crypto/modes/xts128.o \
  crypto/modes/wrap128.o \
  crypto/bn/bn_add.o \
  crypto/bn/bn_div.o \
  crypto/bn/bn_exp.o \
  crypto/bn/bn_lib.o \
  crypto/bn/bn_ctx.o \
  crypto/bn/bn_mul.o \
  crypto/bn/bn_mod.o \
  crypto/bn/bn_print.o \
  crypto/bn/bn_rand.o \
  crypto/bn/bn_shift.o \
  crypto/bn/bn_word.o \
  crypto/bn/bn_blind.o \
  crypto/bn/bn_kron.o \
  crypto/bn/bn_sqrt.o \
  crypto/bn/bn_gcd.o \
  crypto/bn/bn_prime.o \
  crypto/bn/bn_err.o \
  crypto/bn/bn_sqr.o \
  crypto/bn/bn_asm.o \
  crypto/bn/bn_recp.o \
  crypto/bn/bn_mont.o \
  crypto/bn/bn_mpi.o \
  crypto/bn/bn_exp2.o \
  crypto/bn/bn_gf2m.o \
  crypto/bn/bn_nist.o \
  crypto/bn/bn_depr.o \
  crypto/bn/bn_x931p.o \
  crypto/bn/bn_const.o \
  crypto/rsa/rsa_eay.o \
  crypto/rsa/rsa_gen.o \
  crypto/rsa/rsa_lib.o \
  crypto/rsa/rsa_sign.o \
  crypto/rsa/rsa_saos.o \
  crypto/rsa/rsa_err.o \
  crypto/rsa/rsa_pk1.o \
  crypto/rsa/rsa_ssl.o \
  crypto/rsa/rsa_none.o \
  crypto/rsa/rsa_oaep.o \
  crypto/rsa/rsa_chk.o \
  crypto/rsa/rsa_null.o \
  crypto/rsa/rsa_pss.o \
  crypto/rsa/rsa_x931.o \
  crypto/rsa/rsa_asn1.o \
  crypto/rsa/rsa_depr.o \
  crypto/rsa/rsa_ameth.o \
  crypto/rsa/rsa_prn.o \
  crypto/rsa/rsa_pmeth.o \
  crypto/rsa/rsa_crpt.o \
  crypto/dso/dso_dl.o \
  crypto/dso/dso_dlfcn.o \
  crypto/dso/dso_err.o \
  crypto/dso/dso_lib.o \
  crypto/dso/dso_null.o \
  crypto/dso/dso_openssl.o \
  crypto/dso/dso_win32.o \
  crypto/dso/dso_vms.o \
  crypto/dso/dso_beos.o \
  crypto/dh/dh_asn1.o \
  crypto/dh/dh_gen.o \
  crypto/dh/dh_key.o \
  crypto/dh/dh_lib.o \
  crypto/dh/dh_check.o \
  crypto/dh/dh_err.o \
  crypto/dh/dh_depr.o \
  crypto/dh/dh_ameth.o \
  crypto/dh/dh_pmeth.o \
  crypto/dh/dh_prn.o \
  crypto/dh/dh_rfc5114.o \
  crypto/buffer/buffer.o \
  crypto/buffer/buf_str.o \
  crypto/buffer/buf_err.o \
  crypto/bio/bio_lib.o \
  crypto/bio/bio_cb.o \
  crypto/bio/bio_err.o \
  crypto/bio/bss_mem.o \
  crypto/bio/bss_null.o \
  crypto/bio/bss_fd.o \
  crypto/bio/bss_file.o \
  crypto/bio/bss_sock.o \
  crypto/bio/bss_conn.o \
  crypto/bio/bf_null.o \
  crypto/bio/bf_buff.o \
  crypto/bio/b_dump.o \
  crypto/bio/b_print.o \
  crypto/bio/b_sock.o \
  crypto/bio/bss_acpt.o \
  crypto/bio/bf_nbio.o \
  crypto/bio/bss_log.o \
  crypto/bio/bss_bio.o \
  crypto/bio/bss_dgram.o \
  crypto/stack/stack.o \
  crypto/lhash/lhash.o \
  crypto/lhash/lh_stats.o \
  crypto/rand/md_rand.o \
  crypto/rand/randfile.o \
  crypto/rand/rand_lib.o \
  crypto/rand/rand_err.o \
  crypto/rand/rand_unix.o \
  crypto/err/err.o \
  crypto/err/err_all.o \
  crypto/err/err_prn.o \
  crypto/objects/o_names.o \
  crypto/objects/obj_dat.o \
  crypto/objects/obj_lib.o \
  crypto/objects/obj_err.o \
  crypto/objects/obj_xref.o \
  crypto/evp/encode.o \
  crypto/evp/digest.o \
  crypto/evp/evp_enc.o \
  crypto/evp/evp_key.o \
  crypto/evp/evp_acnf.o \
  crypto/evp/evp_cnf.o \
  crypto/evp/e_des.o \
  crypto/evp/e_bf.o \
  crypto/evp/e_idea.o \
  crypto/evp/e_des3.o \
  crypto/evp/e_camellia.o \
  crypto/evp/e_rc4.o \
  crypto/evp/e_aes.o \
  crypto/evp/names.o \
  crypto/evp/e_seed.o \
  crypto/evp/e_xcbc_d.o \
  crypto/evp/e_rc2.o \
  crypto/evp/e_cast.o \
  crypto/evp/e_rc5.o \
  crypto/evp/m_null.o \
  crypto/evp/m_md2.o \
  crypto/evp/m_md4.o \
  crypto/evp/m_md5.o \
  crypto/evp/m_sha.o \
  crypto/evp/m_sha1.o \
  crypto/evp/m_wp.o \
  crypto/evp/m_dss.o \
  crypto/evp/m_dss1.o \
  crypto/evp/m_mdc2.o \
  crypto/evp/m_ripemd.o \
  crypto/evp/m_ecdsa.o \
  crypto/evp/p_open.o \
  crypto/evp/p_seal.o \
  crypto/evp/p_sign.o \
  crypto/evp/p_verify.o \
  crypto/evp/p_lib.o \
  crypto/evp/p_enc.o \
  crypto/evp/p_dec.o \
  crypto/evp/bio_md.o \
  crypto/evp/bio_b64.o \
  crypto/evp/bio_enc.o \
  crypto/evp/evp_err.o \
  crypto/evp/e_null.o \
  crypto/evp/c_all.o \
  crypto/evp/c_allc.o \
  crypto/evp/c_alld.o \
  crypto/evp/evp_lib.o \
  crypto/evp/bio_ok.o \
  crypto/evp/evp_pkey.o \
  crypto/evp/evp_pbe.o \
  crypto/evp/p5_crpt.o \
  crypto/evp/p5_crpt2.o \
  crypto/evp/e_old.o \
  crypto/evp/pmeth_lib.o \
  crypto/evp/pmeth_fn.o \
  crypto/evp/pmeth_gn.o \
  crypto/evp/m_sigver.o \
  crypto/evp/e_aes_cbc_hmac_sha1.o \
  crypto/evp/e_aes_cbc_hmac_sha256.o \
  crypto/evp/e_rc4_hmac_md5.o \
  crypto/asn1/a_object.o \
  crypto/asn1/a_bitstr.o \
  crypto/asn1/a_utctm.o \
  crypto/asn1/a_gentm.o \
  crypto/asn1/a_time.o \
  crypto/asn1/a_int.o \
  crypto/asn1/a_octet.o \
  crypto/asn1/a_print.o \
  crypto/asn1/a_type.o \
  crypto/asn1/a_set.o \
  crypto/asn1/a_dup.o \
  crypto/asn1/a_d2i_fp.o \
  crypto/asn1/a_i2d_fp.o \
  crypto/asn1/a_enum.o \
  crypto/asn1/a_utf8.o \
  crypto/asn1/a_sign.o \
  crypto/asn1/a_digest.o \
  crypto/asn1/a_verify.o \
  crypto/asn1/a_mbstr.o \
  crypto/asn1/a_strex.o \
  crypto/asn1/x_algor.o \
  crypto/asn1/x_val.o \
  crypto/asn1/x_pubkey.o \
  crypto/asn1/x_sig.o \
  crypto/asn1/x_req.o \
  crypto/asn1/x_attrib.o \
  crypto/asn1/x_bignum.o \
  crypto/asn1/x_long.o \
  crypto/asn1/x_name.o \
  crypto/asn1/x_x509.o \
  crypto/asn1/x_x509a.o \
  crypto/asn1/x_crl.o \
  crypto/asn1/x_info.o \
  crypto/asn1/x_spki.o \
  crypto/asn1/nsseq.o \
  crypto/asn1/x_nx509.o \
  crypto/asn1/d2i_pu.o \
  crypto/asn1/d2i_pr.o \
  crypto/asn1/i2d_pu.o \
  crypto/asn1/i2d_pr.o \
  crypto/asn1/t_req.o \
  crypto/asn1/t_x509.o \
  crypto/asn1/t_x509a.o \
  crypto/asn1/t_crl.o \
  crypto/asn1/t_pkey.o \
  crypto/asn1/t_spki.o \
  crypto/asn1/t_bitst.o \
  crypto/asn1/tasn_new.o \
  crypto/asn1/tasn_fre.o \
  crypto/asn1/tasn_enc.o \
  crypto/asn1/tasn_dec.o \
  crypto/asn1/tasn_utl.o \
  crypto/asn1/tasn_typ.o \
  crypto/asn1/tasn_prn.o \
  crypto/asn1/ameth_lib.o \
  crypto/asn1/f_int.o \
  crypto/asn1/f_string.o \
  crypto/asn1/n_pkey.o \
  crypto/asn1/f_enum.o \
  crypto/asn1/x_pkey.o \
  crypto/asn1/a_bool.o \
  crypto/asn1/x_exten.o \
  crypto/asn1/bio_asn1.o \
  crypto/asn1/bio_ndef.o \
  crypto/asn1/asn_mime.o \
  crypto/asn1/asn1_gen.o \
  crypto/asn1/asn1_par.o \
  crypto/asn1/asn1_lib.o \
  crypto/asn1/asn1_err.o \
  crypto/asn1/a_bytes.o \
  crypto/asn1/a_strnid.o \
  crypto/asn1/evp_asn1.o \
  crypto/asn1/asn_pack.o \
  crypto/asn1/p5_pbe.o \
  crypto/asn1/p5_pbev2.o \
  crypto/asn1/p8_pkey.o \
  crypto/asn1/asn_moid.o \
  crypto/pem/pem_sign.o \
  crypto/pem/pem_seal.o \
  crypto/pem/pem_info.o \
  crypto/pem/pem_lib.o \
  crypto/pem/pem_all.o \
  crypto/pem/pem_err.o \
  crypto/pem/pem_x509.o \
  crypto/pem/pem_xaux.o \
  crypto/pem/pem_oth.o \
  crypto/pem/pem_pk8.o \
  crypto/pem/pem_pkey.o \
  crypto/pem/pvkfmt.o \
  crypto/x509/x509_def.o \
  crypto/x509/x509_d2.o \
  crypto/x509/x509_r2x.o \
  crypto/x509/x509_cmp.o \
  crypto/x509/x509_obj.o \
  crypto/x509/x509_req.o \
  crypto/x509/x509spki.o \
  crypto/x509/x509_vfy.o \
  crypto/x509/x509_set.o \
  crypto/x509/x509cset.o \
  crypto/x509/x509rset.o \
  crypto/x509/x509_err.o \
  crypto/x509/x509name.o \
  crypto/x509/x509_v3.o \
  crypto/x509/x509_ext.o \
  crypto/x509/x509_att.o \
  crypto/x509/x509type.o \
  crypto/x509/x509_lu.o \
  crypto/x509/x_all.o \
  crypto/x509/x509_txt.o \
  crypto/x509/x509_trs.o \
  crypto/x509/x509_vpm.o \
  crypto/x509v3/v3_bcons.o \
  crypto/x509v3/v3_bitst.o \
  crypto/x509v3/v3_conf.o \
  crypto/x509v3/v3_extku.o \
  crypto/x509v3/v3_ia5.o \
  crypto/x509v3/v3_lib.o \
  crypto/x509v3/v3_prn.o \
  crypto/x509v3/v3_utl.o \
  crypto/x509v3/v3err.o \
  crypto/x509v3/v3_genn.o \
  crypto/x509v3/v3_alt.o \
  crypto/x509v3/v3_skey.o \
  crypto/x509v3/v3_akey.o \
  crypto/x509v3/v3_pku.o \
  crypto/x509v3/v3_int.o \
  crypto/x509v3/v3_enum.o \
  crypto/x509v3/v3_sxnet.o \
  crypto/x509v3/v3_cpols.o \
  crypto/x509v3/v3_crld.o \
  crypto/x509v3/v3_purp.o \
  crypto/x509v3/v3_info.o \
  crypto/x509v3/v3_ocsp.o \
  crypto/x509v3/v3_akeya.o \
  crypto/x509v3/v3_pmaps.o \
  crypto/x509v3/v3_pcons.o \
  crypto/x509v3/v3_ncons.o \
  crypto/x509v3/v3_pcia.o \
  crypto/x509v3/v3_pci.o \
  crypto/x509v3/pcy_cache.o \
  crypto/x509v3/pcy_node.o \
  crypto/x509v3/pcy_data.o \
  crypto/x509v3/pcy_map.o \
  crypto/x509v3/pcy_tree.o \
  crypto/x509v3/pcy_lib.o \
  crypto/x509v3/v3_asid.o \
  crypto/x509v3/v3_addr.o \
  crypto/conf/conf_err.o \
  crypto/conf/conf_lib.o \
  crypto/conf/conf_api.o \
  crypto/conf/conf_def.o \
  crypto/conf/conf_mod.o \
  crypto/conf/conf_mall.o \
  crypto/conf/conf_sap.o \
  crypto/txt_db/txt_db.o \
  crypto/pkcs7/pk7_asn1.o \
  crypto/pkcs7/pk7_lib.o \
  crypto/pkcs7/pkcs7err.o \
  crypto/pkcs7/pk7_doit.o \
  crypto/pkcs7/pk7_smime.o \
  crypto/pkcs7/pk7_attr.o \
  crypto/pkcs7/pk7_mime.o \
  crypto/pkcs7/bio_pk7.o \
  crypto/pkcs12/p12_add.o \
  crypto/pkcs12/p12_asn.o \
  crypto/pkcs12/p12_attr.o \
  crypto/pkcs12/p12_crpt.o \
  crypto/pkcs12/p12_crt.o \
  crypto/pkcs12/p12_decr.o \
  crypto/pkcs12/p12_init.o \
  crypto/pkcs12/p12_key.o \
  crypto/pkcs12/p12_kiss.o \
  crypto/pkcs12/p12_mutl.o \
  crypto/pkcs12/p12_utl.o \
  crypto/pkcs12/p12_npas.o \
  crypto/pkcs12/pk12err.o \
  crypto/pkcs12/p12_p8d.o \
  crypto/pkcs12/p12_p8e.o \
  crypto/comp/comp_lib.o \
  crypto/comp/comp_err.o \
  crypto/comp/c_rle.o \
  crypto/comp/c_zlib.o \
  crypto/ocsp/ocsp_asn.o \
  crypto/ocsp/ocsp_ext.o \
  crypto/ocsp/ocsp_ht.o \
  crypto/ocsp/ocsp_lib.o \
  crypto/ocsp/ocsp_cl.o \
  crypto/ocsp/ocsp_srv.o \

=== debian/changelog ===
shim (0.9+1474479173.6c180c6-1) unstable; urgency=medium

  [ Steve Langasek ]
  * Initial Debian upload.  Closes: #820052.
  * Update Standards-Version.
  * Embed the newly-minted Debian CA certificate.
  * Vendorize debian/rules so that the same package can be used in both
    Debian and Ubuntu without modification.
  * Fix debian/copyright to match the spec (last match wins, not first)
  * Fix shim.efi to not be executable.
  * Add watchfile.
  * Support parallel builds, because eh why not
  * Update Vcs-Bzr.
  * Resync with Ubuntu, including patch to fix debian/copyright.

  [ Julien Cristau ]
  * Add some missing copyright holders in d/copyright, update
    Upstream-Contact.  Thanks to Helen Koike for the help.

 -- Julien Cristau <jcristau@debian.org>  Sat, 15 Oct 2016 15:17:34 +0200

shim (0.9+1474479173.6c180c6-0ubuntu1) UNRELEASED; urgency=medium

  [ Helen Koike ]
  * debian/copyright: add OpenSSL license 

  [ Mathieu Trudel-Lapierre ]
  * New upstream release.
  * debian/copyright: patches should be BSD, like the rest of the upstream
    code.
  * debian/patches/unused-variable: dropped; applied upstream.
  * debian/patches/binutils-version-matching: dropped, fixed upstream.
  * debian/shim.install: built EFI binaries were renamed; update our install
    file to properly pick up shim (shim$arch), MokManager (mm$arch), and
    fallback (fb$arch).

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 21 Sep 2016 20:29:44 -0400

=== debian/control ===
Source: shim
Section: admin
Priority: optional
Maintainer: Steve Langasek <vorlon@debian.org>
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9), gnu-efi (>= 3.0u), sbsigntool, openssl
Vcs-Bzr: lp:~ubuntu-core-dev/shim/trunk

Package: shim
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: boot loader to chain-load signed boot loaders under Secure Boot
 This package provides a minimalist boot loader which allows verifying
 signatures of other UEFI binaries against either the Secure Boot DB/DBX or
 against a built-in signature database.  Its purpose is to allow a small,
 infrequently-changing binary to be signed by the UEFI CA, while allowing
 an OS distributor to revision their main bootloader independently of the CA.

=== debian/rules ===
#!/usr/bin/make -f

# Other vendors, add your certs here.  No sense in using
# dpkg-vendor --derives-from, because only Canonical-generated binaries will
# be signed with this key; so if you are building your own shim binary you
# should be building the other binaries also.
ifeq ($(shell dpkg-vendor --is ubuntu && echo yes),yes)
	cert=debian/canonical-uefi-ca.der
else
	cert=debian/debian-uefi-ca.der
endif

%:
	dh $@ --parallel

override_dh_auto_build:
	dh_auto_build -- EFI_PATH=/usr/lib VENDOR_CERT_FILE=$(cert)

override_dh_fixperms:
	dh_fixperms
	chmod a-x debian/shim/usr/lib/shim/shimx64.efi

## shim 13

=== Makefile ===
VERSION		= 13
ifneq ($(origin RELEASE),undefined)
DASHRELEASE	?= -$(RELEASE)
else
DASHRELEASE	?=
endif

ifeq ($(MAKELEVEL),0)
TOPDIR		?= $(shell pwd)
endif
override TOPDIR	:= $(abspath $(TOPDIR))
VPATH		= $(TOPDIR)

CC		= $(CROSS_COMPILE)gcc
LD		= $(CROSS_COMPILE)ld
OBJCOPY		= $(CROSS_COMPILE)objcopy
OPENSSL		?= openssl
HEXDUMP		?= hexdump
INSTALL		?= install
PK12UTIL	?= pk12util
CERTUTIL	?= certutil
PESIGN		?= pesign
SBSIGN		?= sbsign
prefix		?= /usr
prefix		:= $(abspath $(prefix))
datadir		?= $(prefix)/share/
PKGNAME		?= shim
ESPROOTDIR	?= boot/efi/
EFIBOOTDIR	?= $(ESPROOTDIR)EFI/BOOT/
TARGETDIR	?= $(ESPROOTDIR)EFI/$(EFIDIR)/
DATATARGETDIR	?= $(datadir)/$(PKGNAME)/$(VERSION)$(DASHRELEASE)/$(ARCH_SUFFIX)/
DEBUGINFO	?= $(prefix)/lib/debug/
DEBUGSOURCE	?= $(prefix)/src/debug/
OSLABEL		?= $(EFIDIR)
DEFAULT_LOADER	?= \\\\grub$(ARCH_SUFFIX).efi

ARCH		?= $(shell $(CC) -dumpmachine | cut -f1 -d- | sed s,i[3456789]86,ia32,)
OBJCOPY_GTE224	= $(shell expr `$(OBJCOPY) --version |grep ^"GNU objcopy" | sed 's/^.*\((.*)\|version\) //g' | cut -f1-2 -d.` \>= 2.24)

SUBDIRS		= $(TOPDIR)/Cryptlib $(TOPDIR)/lib

EFI_INCLUDE	:= /usr/include/efi
EFI_INCLUDES	= -nostdinc -I$(TOPDIR)/Cryptlib -I$(TOPDIR)/Cryptlib/Include \
		  -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol \
		  -I$(TOPDIR)/include -iquote $(TOPDIR) -iquote $(shell pwd)

LIB_GCC		= $(shell $(CC) -print-libgcc-file-name)
EFI_LIBS	= -lefi -lgnuefi --start-group Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a --end-group $(LIB_GCC) 

EFI_CRT_OBJS 	= $(EFI_PATH)/crt0-efi-$(ARCH).o
EFI_LDS		= $(TOPDIR)/elf_$(ARCH)_efi.lds

CFLAGS		= -ggdb -O0 -fno-stack-protector -fno-strict-aliasing -fpic \
		  -fshort-wchar -Wall -Wsign-compare -Werror -fno-builtin \
		  -Werror=sign-compare -ffreestanding -std=gnu89 \
		  -I$(shell $(CC) -print-file-name=include) \
		  "-DDEFAULT_LOADER=L\"$(DEFAULT_LOADER)\"" \
		  "-DDEFAULT_LOADER_CHAR=\"$(DEFAULT_LOADER)\"" \
		  $(EFI_INCLUDES)

COMMITID ?= $(shell if [ -d .git ] ; then git log -1 --pretty=format:%H ; elif [ -f commit ]; then cat commit ; else echo commit id not available; fi)

ifneq ($(origin OVERRIDE_SECURITY_POLICY), undefined)
	CFLAGS	+= -DOVERRIDE_SECURITY_POLICY
endif

ifneq ($(origin ENABLE_HTTPBOOT), undefined)
	CFLAGS	+= -DENABLE_HTTPBOOT
endif

ifeq ($(ARCH),x86_64)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc \
		   -maccumulate-outgoing-args \
		   -DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI \
		   -DNO_BUILTIN_VA_FUNCS -DMDE_CPU_X64 -DPAGE_SIZE=4096
	LIBDIR			?= $(prefix)/lib64
	ARCH_SUFFIX		?= x64
	ARCH_SUFFIX_UPPER	?= X64
	ARCH_LDFLAGS		?=
endif
ifeq ($(ARCH),ia32)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc \
		   -maccumulate-outgoing-args -m32 \
		   -DMDE_CPU_IA32 -DPAGE_SIZE=4096
	LIBDIR			?= $(prefix)/lib
	ARCH_SUFFIX		?= ia32
	ARCH_SUFFIX_UPPER	?= IA32
	ARCH_LDFLAGS		?=
endif
ifeq ($(ARCH),aarch64)
	CFLAGS += -DMDE_CPU_AARCH64 -DPAGE_SIZE=4096 -mstrict-align
	LIBDIR			?= $(prefix)/lib64
	ARCH_SUFFIX		?= aa64
	ARCH_SUFFIX_UPPER	?= AA64
	FORMAT			:= -O binary
	SUBSYSTEM		:= 0xa
	ARCH_LDFLAGS		+= --defsym=EFI_SUBSYSTEM=$(SUBSYSTEM)
endif
ifeq ($(ARCH),arm)
	CFLAGS += -DMDE_CPU_ARM -DPAGE_SIZE=4096 -mstrict-align
	LIBDIR			?= $(prefix)/lib
	ARCH_SUFFIX		?= arm
	ARCH_SUFFIX_UPPER	?= ARM
	FORMAT			:= -O binary
	SUBSYSTEM		:= 0xa
	ARCH_LDFLAGS		+= --defsym=EFI_SUBSYSTEM=$(SUBSYSTEM)
endif

FORMAT		?= --target efi-app-$(ARCH)
EFI_PATH	?= $(LIBDIR)/gnuefi

MMSTEM		?= mm$(ARCH_SUFFIX)
MMNAME		= $(MMSTEM).efi
MMSONAME	= $(MMSTEM).so
FBSTEM		?= fb$(ARCH_SUFFIX)
FBNAME		= $(FBSTEM).efi
FBSONAME	= $(FBSTEM).so
SHIMSTEM	?= shim$(ARCH_SUFFIX)
SHIMNAME	= $(SHIMSTEM).efi
SHIMSONAME	= $(SHIMSTEM).so
SHIMHASHNAME	= $(SHIMSTEM).hash
BOOTEFINAME	?= BOOT$(ARCH_SUFFIX_UPPER).EFI
BOOTCSVNAME	?= BOOT$(ARCH_SUFFIX_UPPER).CSV

CFLAGS += "-DEFI_ARCH=L\"$(ARCH_SUFFIX)\"" "-DDEBUGDIR=L\"/usr/lib/debug/usr/share/shim/$(ARCH_SUFFIX)-$(VERSION)$(DASHRELEASE)/\""

ifneq ($(origin VENDOR_CERT_FILE), undefined)
	CFLAGS += -DVENDOR_CERT_FILE=\"$(VENDOR_CERT_FILE)\"
endif
ifneq ($(origin VENDOR_DBX_FILE), undefined)
	CFLAGS += -DVENDOR_DBX_FILE=\"$(VENDOR_DBX_FILE)\"
endif

LDFLAGS		= --hash-style=sysv -nostdlib -znocombreloc -T $(EFI_LDS) -shared -Bsymbolic -L$(EFI_PATH) -L$(LIBDIR) -LCryptlib -LCryptlib/OpenSSL $(EFI_CRT_OBJS) --build-id=sha1 $(ARCH_LDFLAGS)

TARGETS	= $(SHIMNAME)
TARGETS += $(SHIMNAME).debug $(MMNAME).debug $(FBNAME).debug
ifneq ($(origin ENABLE_SHIM_HASH),undefined)
TARGETS += $(SHIMHASHNAME)
endif
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
TARGETS	+= $(MMNAME).signed $(FBNAME).signed
CFLAGS += -DENABLE_SHIM_CERT
else
TARGETS += $(MMNAME) $(FBNAME)
endif
OBJS	= shim.o netboot.o cert.o replacements.o tpm.o version.o errlog.o
KEYS	= shim_cert.h ocsp.* ca.* shim.crt shim.csr shim.p12 shim.pem shim.key shim.cer
ORIG_SOURCES	= shim.c shim.h netboot.c include/PeImage.h include/wincert.h include/console.h replacements.c replacements.h tpm.c tpm.h version.h errlog.c
MOK_OBJS = MokManager.o PasswordCrypt.o crypt_blowfish.o
ORIG_MOK_SOURCES = MokManager.c shim.h include/console.h PasswordCrypt.c PasswordCrypt.h crypt_blowfish.c crypt_blowfish.h
FALLBACK_OBJS = fallback.o tpm.o
ORIG_FALLBACK_SRCS = fallback.c

ifneq ($(origin ENABLE_HTTPBOOT), undefined)
	OBJS += httpboot.o
	SOURCES += httpboot.c httpboot.h
endif

SOURCES = $(foreach source,$(ORIG_SOURCES),$(TOPDIR)/$(source)) version.c
MOK_SOURCES = $(foreach source,$(ORIG_MOK_SOURCES),$(TOPDIR)/$(source))
FALLBACK_SRCS = $(foreach source,$(ORIG_FALLBACK_SRCS),$(TOPDIR)/$(source))

all: $(TARGETS)

shim.crt:
	$(TOPDIR)/make-certs shim shim@xn--u4h.net all codesign 1.3.6.1.4.1.311.10.3.1 </dev/null

shim.cer: shim.crt
	$(OPENSSL) x509 -outform der -in $< -out $@

.NOTPARALLEL: shim_cert.h
shim_cert.h: shim.cer
	echo "static UINT8 shim_cert[] __attribute__((__unused__)) = {" > $@
	$(HEXDUMP) -v -e '1/1 "0x%02x, "' $< >> $@
	echo "};" >> $@

version.c : $(TOPDIR)/version.c.in
	sed	-e "s,@@VERSION@@,$(VERSION)," \
		-e "s,@@UNAME@@,$(shell uname -a)," \
		-e "s,@@COMMIT@@,$(COMMITID)," \
		< $< > $@

certdb/secmod.db: shim.crt
	-mkdir certdb
	$(PK12UTIL) -d certdb/ -i shim.p12 -W "" -K ""
	$(CERTUTIL) -d certdb/ -A -i shim.crt -n shim -t u

shim.o: $(SOURCES)
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
shim.o: shim_cert.h
endif
shim.o: $(wildcard $(TOPDIR)/*.h)

cert.o : $(TOPDIR)/cert.S
	$(CC) $(CFLAGS) -c -o $@ $<

$(SHIMNAME) : $(SHIMSONAME)
$(MMNAME) : $(MMSONAME)
$(FBNAME) : $(FBSONAME)

$(SHIMSONAME): $(OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)

fallback.o: $(FALLBACK_SRCS)

$(FBSONAME): $(FALLBACK_OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)

MokManager.o: $(MOK_SOURCES)

$(MMSONAME): $(MOK_OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS) lib/lib.a

Cryptlib/libcryptlib.a:
	mkdir -p Cryptlib/{Hash,Hmac,Cipher,Rand,Pk,Pem,SysCall}
	$(MAKE) VPATH=$(TOPDIR)/Cryptlib TOPDIR=$(TOPDIR)/Cryptlib -C Cryptlib -f $(TOPDIR)/Cryptlib/Makefile

Cryptlib/OpenSSL/libopenssl.a:
	mkdir -p Cryptlib/OpenSSL/crypto/{x509v3,x509,txt_db,stack,sha,rsa,rc4,rand,pkcs7,pkcs12,pem,ocsp,objects,modes,md5,lhash,kdf,hmac,evp,err,dso,dh,conf,comp,cmac,buffer,bn,bio,async{,/arch},asn1,aes}/
	$(MAKE) VPATH=$(TOPDIR)/Cryptlib/OpenSSL TOPDIR=$(TOPDIR)/Cryptlib/OpenSSL -C Cryptlib/OpenSSL -f $(TOPDIR)/Cryptlib/OpenSSL/Makefile

lib/lib.a:
	if [ ! -d lib ]; then mkdir lib ; fi
	$(MAKE) VPATH=$(TOPDIR)/lib TOPDIR=$(TOPDIR) CFLAGS="$(CFLAGS)" -C lib -f $(TOPDIR)/lib/Makefile

buildid : $(TOPDIR)/buildid.c
	$(CC) -Og -g3 -Wall -Werror -Wextra -o $@ $< -lelf

$(BOOTCSVNAME) :
	@echo Making $@
	@echo "$(SHIMNAME),$(OSLABEL),,This is the boot entry for $(OSLABEL)" | iconv -t UCS-2LE > $@

install-check :
ifeq ($(origin LIBDIR),undefined)
	$(error Architecture $(ARCH) is not a supported build target.)
endif
ifeq ($(origin EFIDIR),undefined)
	$(error EFIDIR must be set to your reserved EFI System Partition subdirectory name)
endif

install-deps : $(TARGETS)
install-deps : $(SHIMNAME).debug $(MMNAME).debug $(FBNAME).debug buildid
install-deps : $(BOOTCSVNAME)

install-debugsource : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)
	find $(TOPDIR) -type f -a '(' -iname '*.c' -o -iname '*.h' -o -iname '*.S' ')' | while read file ; do \
		outfile=$$(echo $${file} | sed -e "s,^$(TOPDIR),,") ; \
		$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)/$$(dirname $${outfile}) ; \
		$(INSTALL) -m 0644 $${file} $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)/$${outfile} ; \
	done

install-debuginfo : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGINFO)$(TARGETDIR)/
	@./buildid $(wildcard *.efi.debug) | while read file buildid ; do \
		first=$$(echo $${buildid} | cut -b -2) ; \
		rest=$$(echo $${buildid} | cut -b 3-) ; \
		$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/ ;\
		$(INSTALL) -m 0644 $${file} $(DESTDIR)/$(DEBUGINFO)$(TARGETDIR) ; \
		ln -s ../../../../..$(DEBUGINFO)$(TARGETDIR)$${file} $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/$${rest}.debug ;\
		ln -s ../../../.build-id/$${first}/$${rest} $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/$${rest} ;\
	done

install : | install-check
install : install-deps install-debuginfo install-debugsource
	$(INSTALL) -d -m 0755 $(DESTDIR)/
	$(INSTALL) -d -m 0700 $(DESTDIR)/$(ESPROOTDIR)
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(EFIBOOTDIR)
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(TARGETDIR)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(EFIBOOTDIR)/$(BOOTEFINAME)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(TARGETDIR)/
	$(INSTALL) -m 0644 $(BOOTCSVNAME) $(DESTDIR)/$(TARGETDIR)/
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
	$(INSTALL) -m 0644 $(FBNAME).signed $(DESTDIR)/$(EFIBOOTDIR)/$(FBNAME)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(EFIBOOTDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(TARGETDIR)/$(MMNAME)
else
	$(INSTALL) -m 0644 $(FBNAME) $(DESTDIR)/$(EFIBOOTDIR)/
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(EFIBOOTDIR)/
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(TARGETDIR)/
endif

install-as-data : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DATATARGETDIR)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(DATATARGETDIR)/
ifneq ($(origin ENABLE_SHIM_HASH),undefined)
	$(INSTALL) -m 0644 $(SHIMHASHNAME) $(DESTDIR)/$(DATATARGETDIR)/
endif
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(DATATARGETDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(FBNAME).signed $(DESTDIR)/$(DATATARGETDIR)/$(FBNAME)
else
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(DATATARGETDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(FBNAME) $(DESTDIR)/$(DATATARGETDIR)/$(FBNAME)
endif

%.efi: %.so
ifneq ($(OBJCOPY_GTE224),1)
	$(error objcopy >= 2.24 is required)
endif
	$(OBJCOPY) -j .text -j .sdata -j .data -j .data.ident \
		-j .dynamic -j .dynsym -j .rel* \
		-j .rela* -j .reloc -j .eh_frame \
		-j .vendor_cert \
		$(FORMAT) $^ $@

ifneq ($(origin ENABLE_SHIM_HASH),undefined)
%.hash : %.efi
	$(PESIGN) -i $< -P -h > $@
endif

%.efi.debug : %.so
ifneq ($(OBJCOPY_GTE224),1)
	$(error objcopy >= 2.24 is required)
endif
	$(OBJCOPY) -j .text -j .sdata -j .data \
		-j .dynamic -j .dynsym -j .rel* \
		-j .rela* -j .reloc -j .eh_frame \
		-j .debug_info -j .debug_abbrev -j .debug_aranges \
		-j .debug_line -j .debug_str -j .debug_ranges \
		-j .note.gnu.build-id \
		$^ $@

ifneq ($(origin ENABLE_SBSIGN),undefined)
%.efi.signed: %.efi shim.key shim.crt
	$(SBSIGN) --key shim.key --cert shim.crt --output $@ $<
else
%.efi.signed: %.efi certdb/secmod.db
	$(PESIGN) -n certdb -i $< -c "shim" -s -o $@ -f
endif

clean: OBJS=$(wildcard *.o)
clean:
	$(MAKE) -C Cryptlib -f $(TOPDIR)/Cryptlib/Makefile clean
	$(MAKE) -C Cryptlib/OpenSSL -f $(TOPDIR)/Cryptlib/OpenSSL/Makefile clean

=== Cryptlib/Makefile ===

EFI_INCLUDES	= -I$(TOPDIR)/Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol

CFLAGS		= -ggdb -O0 -I$(TOPDIR) -iquote $(TOPDIR) -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar \
		  -Wall $(EFI_INCLUDES) -std=gnu89 \
		  -ffreestanding -I$(shell $(CC) -print-file-name=include)

ifeq ($(ARCH),x86_64)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc -maccumulate-outgoing-args \
		-DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI -DNO_BUILTIN_VA_FUNCS \
		-DMDE_CPU_X64
endif
ifeq ($(ARCH),ia32)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc -maccumulate-outgoing-args -m32 \
		-DMDE_CPU_IA32
endif
ifeq ($(ARCH),aarch64)
	CFLAGS	+= -DMDE_CPU_AARCH64
endif
LDFLAGS		= -nostdlib -znocombreloc

TARGET		= libcryptlib.a
OBJS		=   Hash/CryptMd4Null.o \
		    Hash/CryptMd5.o \
		    Hash/CryptSha1.o \
		    Hash/CryptSha256.o \
		    Hash/CryptSha512.o \
		    Hmac/CryptHmacMd5Null.o \
		    Hmac/CryptHmacSha1Null.o \
		    Hmac/CryptHmacSha256Null.o \
		    Cipher/CryptAesNull.o \
		    Cipher/CryptTdesNull.o \
		    Cipher/CryptArc4Null.o \
		    Rand/CryptRand.o \
		    Pk/CryptRsaBasic.o \
		    Pk/CryptRsaExtNull.o \
		    Pk/CryptPkcs7SignNull.o \
		    Pk/CryptPkcs7Verify.o \
		    Pk/CryptDhNull.o \
		    Pk/CryptTs.o \
		    Pk/CryptX509.o \
		    Pk/CryptAuthenticode.o \
		    Pem/CryptPem.o \
		    SysCall/CrtWrapper.o \
		    SysCall/TimerWrapper.o \
		    SysCall/BaseMemAllocation.o \
		    SysCall/BaseStrings.o \
		    SysCall/memset.o

all: $(TARGET)

libcryptlib.a: $(OBJS)
	ar rcs libcryptlib.a $(OBJS)
clean:
	rm -f $(TARGET) $(OBJS)

=== Cryptlib/OpenSSL/Makefile ===
--- 
+++ 
@@ -1,14 +1,17 @@
 
-EFI_INCLUDES	= -I../Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol -Icrypto/asn1 -Icrypto/evp -Icrypto/modes
-
-CFLAGS		= -ggdb -O0 -I. -I.. -I../Include/ -Icrypto -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar -nostdinc \
+EFI_INCLUDES	= -I$(TOPDIR)/../Include \
+		  -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol \
+		  -I$(TOPDIR)/crypto/asn1 -I$(TOPDIR)/crypto/evp -I$(TOPDIR)/crypto/modes -I$(TOPDIR)/crypto/include
+
+CFLAGS		= -ggdb -O0 -I$(TOPDIR) -I$(TOPDIR)/.. -I$(TOPDIR)/../Include/ -I$(TOPDIR)/crypto \
+		  -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar -nostdinc \
 		  -ffreestanding -std=gnu89 -I$(shell $(CC) -print-file-name=include) \
 		  -Wall $(EFI_INCLUDES) -DL_ENDIAN -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DOPENSSL_SMALL_FOOTPRINT -DPEDANTIC
 
 ifeq ($(ARCH),x86_64)
 	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -maccumulate-outgoing-args \
 		-DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI \
-		-UNO_BUILTIN_VA_FUNCS -DMDE_CPU_IA64
+		-UNO_BUILTIN_VA_FUNCS -DMDE_CPU_X64
 endif
 ifeq ($(ARCH),ia32)
 	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -maccumulate-outgoing-args \
@@ -38,8 +41,6 @@
   crypto/o_fips.o \
   crypto/o_init.o \
   crypto/fips_ers.o \
-  crypto/md4/md4_dgst.o \
-  crypto/md4/md4_one.o \
   crypto/md5/md5_dgst.o \
   crypto/md5/md5_one.o \
   crypto/sha/sha_dgst.o \
@@ -51,32 +52,6 @@
   crypto/hmac/hmac.o \
   crypto/hmac/hm_ameth.o \
   crypto/hmac/hm_pmeth.o \
-  crypto/des/set_key.o \
-  crypto/des/ecb_enc.o \
-  crypto/des/cbc_enc.o \
-  crypto/des/ecb3_enc.o \
-  crypto/des/cfb64enc.o \
-  crypto/des/cfb64ede.o \
-  crypto/des/cfb_enc.o \
-  crypto/des/ofb64ede.o \
-  crypto/des/enc_read.o \
-  crypto/des/enc_writ.o \
-  crypto/des/ofb64enc.o \
-  crypto/des/ofb_enc.o \
-  crypto/des/str2key.o \
-  crypto/des/pcbc_enc.o \
-  crypto/des/qud_cksm.o \
-  crypto/des/rand_key.o \
-  crypto/des/des_enc.o \
-  crypto/des/fcrypt_b.o \
-  crypto/des/fcrypt.o \
-  crypto/des/xcbc_enc.o \
-  crypto/des/rpc_enc.o \
-  crypto/des/cbc_cksm.o \
-  crypto/des/ede_cbcm_enc.o \
-  crypto/des/des_old.o \
-  crypto/des/des_old2.o \
-  crypto/des/read2pwd.o \
   crypto/rc4/rc4_enc.o \
   crypto/rc4/rc4_skey.o \
   crypto/rc4/rc4_utl.o \
@@ -452,3 +427,17 @@
   crypto/ocsp/ocsp_lib.o \
   crypto/ocsp/ocsp_cl.o \
   crypto/ocsp/ocsp_srv.o \
+  crypto/ocsp/ocsp_prn.o \
+  crypto/ocsp/ocsp_vfy.o \
+  crypto/ocsp/ocsp_err.o \
+  crypto/cmac/cmac.o \
+  crypto/cmac/cm_ameth.o \
+  crypto/cmac/cm_pmeth.o \
+
+all: $(TARGET)
+
+libopenssl.a: $(OBJS)
+	ar rcs libopenssl.a $(OBJS)
+
+clean:
+	rm -f $(TARGET) $(OBJS)

=== debian/changelog ===
shim (13-0ubuntu2) bionic; urgency=medium

  * debian/patches/abort_abort_abort.patch: signtool.exe isn't happy with some
    of the structure of our binary, partly because abort() is thought to be an
    external symbol, which causes some relocalisations to appear.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 07 Nov 2017 10:19:04 -0500

shim (13-0ubuntu1) artful; urgency=medium

  * New upstream release: 13
  * debian/control: add a Build-Depends on libelf-dev.
  * debian/control: add Breaks: for the previous shim-signed builds given
    that shim will now build and ship BOOT.CSV by itself.
  * debian/rules:
    - Update dh_auto_build/dh_auto_clean/dh_auto_install for new upstream
      options: set MAKELEVEL.
    - Define an EFI_ARCH variable, and use that for paths to shim. This
      makes it possible to build a shim for other architectures than amd64.
    - Set EFIDIR=ubuntu for dh_auto_install; that will let files be installed
      in the "right" final directories, and makes boot.csv for us.
    - Set ENABLE_SHIM_CERT, to keep using ephemeral self-signed certs built
      at compile-time for MokManager and fallback.
    - Set ENABLE_SBSIGN, to use sbsign instead of pesign for signing fallback
      and MokManager.
  * debian/patches/second-stage-path: dropped; the default loader path now
    includes an arch suffix.
  * debian/patches/sbsigntool-no-pesign: dropped; no longer needed..
  * debian/patches/0001-shim-fix-the-mirroring-MokSBState-fail.patch: dropped,
    included upstream.
  * debian/shim.install: update paths in light of using shim's upstream install
    target.
  * debian/rules, debian/shim.install: make sure the 'make install' step does
    what it's meant to do by upstream: we can easily make use of the end result
    to have the files we need.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 29 Sep 2017 15:11:28 -0400

shim (0.9+1474479173.6c180c6-1ubuntu1) zesty; urgency=medium

  [ Steve Langasek ]
  * Merge (not yet NEW cleared) changes from Debian branch.

  [ Mathieu Trudel-Lapierre ]
  * debian/patches/0001-shim-fix-the-mirroring-MokSBState-fail.patch: guard
    against errors in mirroring MokSBState to MokSBStateRT. Thanks to Ivan Hu
    for the patch. This will fix issues updating MokSBStateRT if the variable
    already exists with different attributes. (LP: #1644806)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 01 Dec 2016 16:55:50 -0500

shim (0.9+1474479173.6c180c6-0ubuntu1) yakkety; urgency=medium

  [ Helen Koike ]
  * debian/copyright: add OpenSSL license 

  [ Mathieu Trudel-Lapierre ]
  * New upstream release. (LP: #1624096)
  * debian/copyright: patches should be BSD, like the rest of the upstream
    code.
  * debian/patches/unused-variable: dropped; applied upstream.
  * debian/patches/binutils-version-matching: dropped, fixed upstream.
  * debian/shim.install: built EFI binaries were renamed; update our install
    file to properly pick up shim (shim$arch), MokManager (mm$arch), and
    fallback (fb$arch).

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 22 Sep 2016 15:02:20 -0400

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: shim
 Section: admin
 Priority: optional
-Maintainer: Steve Langasek <vorlon@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Steve Langasek <vorlon@debian.org>
 Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9), gnu-efi (>= 3.0u), sbsigntool, openssl
+Build-Depends: debhelper (>= 9), gnu-efi (>= 3.0u), sbsigntool, openssl, libelf-dev
 Vcs-Bzr: lp:~ubuntu-core-dev/shim/trunk
 
 Package: shim
 Architecture: amd64
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: shim-signed (<< 1.33~)
 Description: boot loader to chain-load signed boot loaders under Secure Boot
  This package provides a minimalist boot loader which allows verifying
  signatures of other UEFI binaries against either the Secure Boot DB/DBX or

=== debian/rules ===
--- 
+++ 
@@ -6,16 +6,37 @@
 # should be building the other binaries also.
 ifeq ($(shell dpkg-vendor --is ubuntu && echo yes),yes)
 	cert=debian/canonical-uefi-ca.der
+	distributor=ubuntu
 else
 	cert=debian/debian-uefi-ca.der
+	distributor=debian
 endif
+
+ifeq ($(DEB_HOST_ARCH),amd64)
+export EFI_ARCH := x64
+endif
+
+COMMON_OPTIONS = \
+	MAKELEVEL=0 \
+	EFI_PATH=/usr/lib \
+	ENABLE_SHIM_CERT=1 \
+	ENABLE_SBSIGN=1 \
+	VENDOR_CERT_FILE=$(cert) \
+	EFIDIR=$(distributor) \
+	$(NULL)
 
 %:
 	dh $@ --parallel
 
+override_dh_auto_clean:
+	dh_auto_clean -- MAKELEVEL=0
+
 override_dh_auto_build:
-	dh_auto_build -- EFI_PATH=/usr/lib VENDOR_CERT_FILE=$(cert)
+	dh_auto_build -- $(COMMON_OPTIONS)
+
+override_dh_auto_install:
+	dh_auto_install --destdir=debian/tmp -- $(COMMON_OPTIONS)
 
 override_dh_fixperms:
 	dh_fixperms
-	chmod a-x debian/shim/usr/lib/shim/shimx64.efi
+	chmod a-x debian/shim/usr/lib/shim/shim$(EFI_ARCH).efi

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="repack,compression=xz,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/shim-$1\.tar\.gz/" \
  https://github.com/mjg59/shim/releases .*/v?(\d\S*)\.tar\.gz
